import pygame
from pygame.locals import *
from practicum import findDevices
from peri import PeriBoard
from random import randrange
import math

##################################################

MaxV = 40
FPS = 60
WINDOW_SIZE = (480,500)
WHITE = pygame.Color('white')
BLACK = pygame.Color('black')
RED = pygame.Color('red')
GREEN = pygame.Color('green')
GREY = pygame.Color('grey')

##################################################

class Ball(object):
	def __init__(self,board):
		self.x = 20
		self.y = 480
		self.radius = 20
		self.color = WHITE
		self.vx = 0
		self.vy = 0
		self.board = board
	
	def update(self, d, display):
		self.x += self.vx*d
		self.y += self.vy*d
		if(self.x < 20):
			self.x = 20
			self.vx = 0
		if(self.y < 20):
			self.y = 20
			self.vy = 0
		if(self.x>460):
			self.x = 460
			self.vx = 0
		if(self.y>480):
			self.y = 480
			self.vy = 0

	def move(self):
		if(self.board.getUP()):
			if(self.vy>-MaxV):
				self.vy -= 2
		else:
			if(self.vy<MaxV):
				self.vy += 2
		if(self.board.getLeft()):
			if(self.vx>-MaxV):
				self.vx -= 2		
		else:
			if(self.vx<MaxV):
				self.vx += 2
				
	def draw(self, display):
        	pos = (int(self.x),int(self.y))
        	pygame.draw.circle(display, self.color, pos, self.radius, 0)

###############################################

class Hole(object):
	def __init__(self, i):
		self.radius = 30
		self.color = RED
		#self.x = randrange(30,470)
		self.x = 30+ i*60
		self.y = randrange(60,470)
	
	def draw(self, display):
		pos = (int(self.x),int(self.y))
        	pygame.draw.circle(display, self.color, pos, self.radius, 0)

	
	def new(self, i):
		self.x = randrange(30,470)
		self.y = randrange(80,420)

###############################################

class End(object):
	def __init__(self):
		self.radius = 50
		self.color = GREEN
		self.x = randrange(30,450)
		self.y = 25
	
	def new(self):
		self.x = randrange(30,450)
		if(self.y == 25):
			self.y = 475
		else :
			self.y = 25
	
	def draw(self,display):
		pos = (int(self.x),int(self.y))
		pygame.draw.circle(display, self.color, pos, self.radius, 0)

##############################################

def render_lvl():
    global font,lvl,lvl_image
    lvl_image = font.render("Level = %d" % lvl, 0, GREY)

##############################################
    
def render_time():
    global font,time,time_image
    time_image = font.render("TIME : %d" % (time/60), 0, GREY)

###############################################

class main():
	global font,lvl,lvl_image,time,time_image
	pygame.init()
	clock = pygame.time.Clock()
	font = pygame.font.SysFont("monospace", 20)
	font2 = pygame.font.SysFont("monospace", 60)
    	lvl = 0
    	lvl_image = None
	time = 1800
	time_image = None
	clock = pygame.time.Clock()
	display = pygame.display.set_mode(WINDOW_SIZE)
    	pygame.display.set_caption('Move my Ball!!')
	board = PeriBoard(findDevices()[0])
	gameover = False
	ball = Ball(board)
	holes = []
	end = End()
	
	while not gameover:
		
		render_time()
		render_lvl()
		for event in pygame.event.get():
			if (event.type == QUIT) or (event.type == KEYDOWN and event.key == K_ESCAPE):
				pygame.quit()
		#if pygame.key.get_pressed()[K_UP]:
		#	ball.vy -= 2
		#elif pygame.key.get_pressed()[K_DOWN]:
		#	ball.vy += 2
		#if pygame.key.get_pressed()[K_LEFT]:
		#	ball.vx -= 2
		#elif pygame.key.get_pressed()[K_RIGHT]:
		#	ball.vx += 2
		ball.move()
		for i in range(9):
			holes.append(Hole(i))
			holes[i].draw(display)
		
                for i in range(9):
                        if (abs(ball.x - holes[i].x) < 25) and (abs(ball.y - holes[i].y) < 25):
				gameover = True
		if(abs(ball.x - end.x) < 35 and abs(ball.y - end.y) < 35):
			end.new()
			if(lvl < 6):
				time += 600 - (lvl*15)
			else:
				time += 500
			lvl += 1
			MaxV += 25
			for i in range(9):
				holes[i].new(display)
				holes.append(Hole(i))
				holes[i].draw(display)

		time -= 1
		if(time <= 0):
			gameover = True
		end.draw(display)
		display.blit(lvl_image, (350,10))
		display.blit(time_image, (10,10))
		ball.draw(display)
		ball.update(1./FPS, display)
		pygame.display.update()
		clock.tick(FPS)
		display.fill(BLACK)

#################################################

if __name__=='__main__':
    main()
    print "Game Over! your total  Level is %d." % lvl
    pygame.quit()
