#include <Practicum.h>

extern "C" {
#include "usbdrv.h"
}

#define RQ_GET_SWITCH1 1
#define RQ_GET_SWITCH2 2

//////////////////////////////////////////////////////////////////////
void setup()
{
    pinMode(PIN_PC2, INPUT_PULLUP);
    pinMode(PIN_PC3, INPUT_PULLUP);

    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}

//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
  static uint8_t switch_state;  /* must stay when usbFunctionSetup returns */

  if (rq->bRequest == RQ_GET_SWITCH1)
  {
    if (digitalRead(PIN_PC3) == LOW) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
      usbMsgPtr = (uint8_t*) &switch_state;
    /* return the number of bytes of data to be returned to host */
    return switch_state;
  } else {
	 if (digitalRead(PIN_PC2) == LOW) /* switch is pressed */
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
      usbMsgPtr = (uint8_t*) &switch_state;
    /* return the number of bytes of data to be returned to host */
    return switch_state;
  }

  /*return 0;   /* nothing to do; return no data back to host */
}


//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
}
